local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/heightmap_ninglor.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_ninglor.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_N_01",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -6,
	MaxHeight = 120,
	VillagePathList = {
		{
			Entrance = { 28, 53, 719 },
			Exit = { 684, 6, 13 }
		},
		{
			Entrance = { 835, 2, 13 },
			Exit = { 835, 2, 13 }
		},
		{
			Entrance = { 49, 33, 395 },
			Exit = { 49, 33, 395}
		},
	},
	SpawnList = {
	   {
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 563, 8, 593 },
			Orientation = { 0 , -159 , 0 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 658, 5, 633 },
			Orientation = { 0.0, 164 , 0.0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 666, 5, 636 },
			Orientation = { 0 , 123, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 4*
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 751, 2, 682 },
			Orientation = { 0 , 121, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 770, 4, 238 },
			Orientation = { 0 , -113, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 761, 4, 256 },
			Orientation = {0 , -129, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 959, 7, 200 },
			Orientation = { 0 , -119, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 980, 10, 177 },
			Orientation = { 0 , -40, 0 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 9
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 987, 8, 299 },
			Orientation = { 0 , -111, 0 },
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 10
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 145, 54, 962 },
			Orientation = { 0 , 70, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 11
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 181, 50, 950 },
			Orientation = { 0 , -109, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 12
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 141, 50, 917 },
			Orientation = { 0 , 86, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 13
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 61, 41, 796 },
			Orientation = { 0 , 93, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 14
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 248, 33, 908 },
			Orientation = { 0 , -174, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 15
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 68, 37, 493 },
			Orientation = { 0 , 125, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 16
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 77, 39, 468 },
			Orientation = { 0 , 29, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 17
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 396, 19, 678 },
			Orientation = { 0 , -48, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 18
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 336, 13, 394 },
			Orientation = { 0 , -36, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 19
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 201, 31, 346  },
			Orientation = { 0 , 132, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 20
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 206, 10, 247 },
			Orientation = { 0 , -174, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 21
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 152, 7, 234 },
			Orientation = { 0 , 139, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 22
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 472, 14, 114 },
			Orientation = { 0 , -147, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 23
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 474, 14, 128 },
			Orientation = { 0 , 0, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 24
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 472, 6, 140 },
			Orientation = { 0 , -9, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 25
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 160, 11, 398 },
			Orientation = { 0 , -41, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 26
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 152, 3, 411 },
			Orientation = { 0 , -108, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 27
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 143, -1, 411 },
			Orientation = { 0 , -138, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 28
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 165, 3, 409 },
			Orientation = { 0 , -142, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		{
			-- creating Mineral Deposit 29
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 107, 24, 147 },
			Orientation = { 0 , 41, 0},
			PatchBeforeVersion = "1.1.0"
		} ,
		},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.9, 0.8, 0.1, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.9
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.9
					},
					ColorRange = {
						Min = { 0.0, 0.6, 0.4, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.3, 0.4, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.4, 0.1, 0.4, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.8,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.2,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.0, 0.45, 0.5, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.917, 0.721, 0.101, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.729, 0.788, 0.811, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})